/*  Filename:  TabLangService.js
 * $Revision: 1.3 $
 *     $Date: 2009/05/31 15:41:43 $
 *
 * TabLang service XPCOM component to share functionality between windows.
 * This file creates only XPCOM component skeleton.
 * All TabLang-related code is in chrome/content/TabLang.js
 * 
 * This  implementation of core functionality of XPCOM component is based on
 * "How to Build an XPCOM Component in Javascript" MDC article. See
 * http://developer.mozilla.org/en/docs/How_to_Build_an_XPCOM_Component_in_Javascript
 * for details and comments on this code
 */

const CLASS_ID = Components.ID("{FEA9CCED-268A-43f6-B373-AD4BADB5E559}");
const CLASS_NAME = "TabLang service to share functionality between windows";
const CONTRACT_ID = "tablang@mozdev.org/tablangservice;1";

function TabLangService() {
	this.wrappedJSObject = this;
	// Initializing TabLang-related properties
	// Including "chrome/content/TabLang.js" where actual implementation goes
	Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
		.getService(Components.interfaces.mozIJSSubScriptLoader)
		.loadSubScript("chrome://tablang/content/TabLang.js");
	// Calling initialization function from TabLang.js
	initTabLangService(this);
}

TabLangService.prototype.QueryInterface = function(aIID) {
	if (!aIID.equals(Components.interfaces.nsISupports))
		throw Components.results.NS_ERROR_NO_INTERFACE;
	return this;
};

var TabLangServiceFactory = {
	createInstance: function (aOuter, aIID)
	{
		if (aOuter != null)
			throw Components.results.NS_ERROR_NO_AGGREGATION;
		return (new TabLangService()).QueryInterface(aIID);
	}
};

var TabLangServiceModule = {
	registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
	{
		aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar)
				.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
	},
	unregisterSelf: function(aCompMgr, aLocation, aType)
	{
		aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar)
				.unregisterFactoryLocation(CLASS_ID, aLocation);        
	},
	getClassObject: function(aCompMgr, aCID, aIID)
	{
		if (!aIID.equals(Components.interfaces.nsIFactory))
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		if (aCID.equals(CLASS_ID))
			return TabLangServiceFactory;
		throw Components.results.NS_ERROR_NO_INTERFACE;
	},
	canUnload: function(aCompMgr) { return true; }
};

function NSGetModule(aCompMgr, aFileSpec) { return TabLangServiceModule; }
